/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 */

#ifndef UKUI_MENU_MENU_EXTENSION_I_FACE_H
#define UKUI_MENU_MENU_EXTENSION_I_FACE_H

#define UKUI_MENU_EXTENSION_TYPE          "UKUI_MENU_EXTENSION"
#define UKUI_MENU_EXTENSION_IFACE_IID     "org.ukui.menu.extension"
#define UKUI_MENU_EXTENSION_IFACE_VERSION "1.0.1"

#include <QObject>
#include <QUrl>
#include <QString>
#include <QVariant>
#include <QtPlugin>

namespace UkuiMenu {

class Q_DECL_EXPORT MenuExtensionIFace : public QObject
{
    Q_OBJECT
public:
    enum Option {
        HideBottomBar,
        HideFullScreenButton
    };
    Q_ENUM(Option)

    explicit MenuExtensionIFace(QObject *parent = nullptr) : QObject(parent) {};
    virtual int index() = 0;
    virtual QString name() = 0;
    virtual QUrl url() = 0;
    virtual QVariantMap data() = 0;
    virtual QVariantList options() { return {}; };
    virtual void receive(QVariantMap data) = 0;

Q_SIGNALS:
    void dataUpdated();
};

}

Q_DECLARE_INTERFACE(UkuiMenu::MenuExtensionIFace, UKUI_MENU_EXTENSION_IFACE_IID)

#endif //UKUI_MENU_MENU_EXTENSION_I_FACE_H
